//Athena - Japanese Based RO Emulator
//atcommand.c
//File Translated September 17, 2003 by Syrus22
//Note: I didn't translate the line above each command because I don't know what it is.

/*Changelog:
October 8, 2003
Syrus22 - Added FULL SubGM and public command support with a new cnf file.
Syrus22 - Changed @rura to @warp.
Syrus22 - Removed RoVeRt's Sub-Gm sections to add new form of Sub-GM support.
Syrus22 - Removed @charmodel and @getmodel to include 3 easier commands.
Syrus22 - Added @chardyehair command.
Syrus22 - Added @chardyeclothes command.
Syrus22 - Added @charstylehair command.
RoVeRT - Moved @where to public section
RoVeRT - Added Sub-GM & Public Command Section
RoVeRT - @charzeny <amount> <name>   - Adds <amount> zeny to <name>
RoVeRT - @charstpoint <amount> <name> - Adds <amount> stat points to <name>
RoVeRT - @charskpoint <amount> <name> - Adds <amount> skill points to <name>
RoVeRT - @getmodel <name> - Gets <names> model
RoVeRT - @charmodel <name - Changes <names> model
RoVeRT - @xp - Displayes current exp and whats needed for next level (non GM)
RoVeRT - added yuno, amatsu and gonryun to @go as numbers 9, 10 and 11 respectivly
October 6, 2003
Syrus22	- Split @doom and @raise into two commands again. 
September 28, 2003
Syrus22 - Made compatible with latest Athena release.
Syrus22 - Added Newest Japanese Athena Commands.
September 27, 2003
Syrus22 - Added @charbaselvl and @charjlvl.
September 24, 2003
Syrus22 - Changed @raiseall to @raise and gave it the map or all option.
Syrus22 - Combined @doom and @doommap
Syrus22 - Changed @rura+ to @charwarp and fixed the space bug.
Syrus22 - Added @doommap command.
September 21, 2003
Syrus22 - Added @raiseall command.
September 20, 2003
Syrus22 - Added @charsave command. 
Syrus22 - Added @night command.
Syrus22 - Added @day command.
Syrus22 - Added @doom command.
September 18, 2003
Syrus22 - Added @charstats command. 
Syrus22 - Added @charoption command.
September 17, 2003
Syrus22 - Added @recall command.
Syrus22 - Added @charjob command.
Syrus22 - Added player locations to @who command.
Syrus22 - Commented out @rura+ command cause it can't work on character names that have spaces.
Syrus22 - Translated all commands and added descriptions.
Syrus22 - Turned @die command into @kill command.
Syrus22 - Fixed @kami command single word bug.
Syrus22 - Commented out @help cause at the moment it doesn't help.
Syrus22 - Commented out @GM cause it is pretty much useless at the moment.
Syrus22 - Commented out @memo cause it's completely pointless.
Syrus22 - Added @revive command.
Syrus22 - Changed @pvp command to @pvpon.
Syrus22 - Changed @lvup and @jlvup to @baselvlup and @joblvlup.*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include "socket.h"
#include "timer.h"

#include "atcommand.h"
#include "clif.h"
#include "chrif.h"
#include "intif.h"
#include "itemdb.h"
#include "map.h"
#include "pc.h"
#include "skill.h"
#include "mob.h"
#include "pet.h"
#include "battle.h"
#include "guild.h"

struct Atcommand_Config atcommand_config;

int atcommand(int fd,struct map_session_data *sd,char *message)
{
	message = strchr(message + strlen(sd->status.name), '@');
	if (message) {	//bZ[W @ ꂽ
		char comand[40];		//@rura Ȃǂ̃VXeR}h񂪓
		char temp0[40];			//1
		char temp1[40];			//2
//      	char temp2[40];         	//3
		char moji[200];			//
		int x = 0, y = 0, z = 0;	//WƂ
		int i1, i2, i3, i;
		int ok = 0;
		struct map_session_data *pl_sd;
		sscanf(message, "%s",comand);

//oV[
//@charwarp <mapname> <x> <y> <char name>
//Description: Warps character to the place of your choice.
		if (strncmpi(comand, "@charwarp",9) == 0) {
			sscanf(message, "%s%s%d%d %[^\n]", comand, temp1, &x, &y, temp0);
			if(atcommand_config.charwarp == 2){
				if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
					ok = 1;
				}
			}else if(atcommand_config.charwarp == 1){
				if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
					ok = 1;
				}else if(sd->status.account_id >= 604554 && sd->status.account_id <= 604583){
					ok = 1;
				}
			}else if(atcommand_config.charwarp == 0){
				ok = 1;
			}
			if(ok == 1){
				if ((pl_sd=map_nick2sd(temp0))!=NULL) {
					if (x >= 0 && x < 400 && y >= 0 && y < 400) {
						if(pc_setpos(pl_sd, temp1, x, y, 2)==0){
							clif_displaymessage(pl_sd->fd,"Warped");
						}else{
							clif_displaymessage(fd,"Warp Failed.");
						}
					}else{
						clif_displaymessage(fd,"Coordinates out of range.");
					}
				}else{
					clif_displaymessage(fd,"Character does not exist.");
				}
			}else{
				clif_displaymessage(fd,"You are not authorized to use this command.");
			}
		return 1;
	}
//[
//@warp <mapname> <xpos> <ypos>
//Description: Warps you to the selected position.
	if (strncmpi(comand, "@warp",5) == 0) {
		sscanf(message, "%s%s%d%d", comand, temp0, &x, &y);
		if(atcommand_config.warp == 2){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}
		}else if(atcommand_config.warp == 1){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}else if(sd->status.account_id >= 604554 && sd->status.account_id <= 604583){
				ok = 1;
			}
		}else if(atcommand_config.warp == 0){
			ok = 1;
		}
		if(ok == 1){
			if (x >= 0 && x < 400 && y >= 0 && y < 400) {
				if(pc_setpos(sd, temp0, x, y, 2)==0){
					clif_displaymessage(fd,"Warped");
				}else{
					clif_displaymessage(fd,"Map not found.");
				}
			}else{
				clif_displaymessage(fd,"Coordinates out of range.");
			}
		}else{
			clif_displaymessage(fd,"You are not authorized to use this command.");
		}
		return 1;
	}
//Cӂ̃L̋ꏊ𒲂ׂ
//@where <char name>
//Description: Tells you the location of a character.
	if(strncmpi(comand, "@where",6) == 0){
		sscanf(message, "%s %[^\n]", comand, temp1);
		if(atcommand_config.where == 2){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}
		}else if(atcommand_config.where == 1){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}else if(sd->status.account_id >= 604554 && sd->status.account_id <= 604583){
				ok = 1;
			}
		}else if(atcommand_config.where == 0){
			ok = 1;
		}
		if(ok == 1){
			if ((pl_sd=map_nick2sd(temp1))!=NULL) {
				sprintf(moji, "%s %s %d %d", temp1, pl_sd->mapname, pl_sd->bl.x, pl_sd->bl.y);
				clif_displaymessage(fd,moji);
			}else{
				clif_displaymessage(fd,"Character does not exist.");
			}
		}else{
			clif_displaymessage(fd,"You are not authorized to use this command.");
		}
		return 1;
	}
//Cӂ̃L̏ֈړ
//Modified by Syrus22 - September 17, 2003
//@jumpto <char name>
//Description: Warps you to selected character.
	if(strncmpi(comand, "@jumpto",7) == 0){
		sscanf(message, "%s %[^\n]", comand, temp1);
		if(atcommand_config.jumpto == 2){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}
		}else if(atcommand_config.jumpto == 1){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}else if(sd->status.account_id >= 604554 && sd->status.account_id <= 604583){
				ok = 1;
			}
		}else if(atcommand_config.jumpto == 0){
			ok = 1;
		}
		if(ok == 1){
			if ((pl_sd=map_nick2sd(temp1))!=NULL) {
				pc_setpos(sd, pl_sd->mapname, pl_sd->bl.x, pl_sd->bl.y, 2);
				sprintf(moji,"Jump to %s",temp1);
				clif_displaymessage(fd,moji);
			}else{
				clif_displaymessage(fd,"Character does not exist.");
			}
		}else{
			clif_displaymessage(fd,"You are not authorized to use this command.");
		}
		return 1;
	}
//}bv̔CӍWɒ
//@jump
//Description: Randomly warps you like a flywing.
	if(strncmpi(comand, "@jump",4) == 0){
		sscanf(message, "%s%d%d", comand, &x, &y);
		if(atcommand_config.jump == 2){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}
		}else if(atcommand_config.jump == 1){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}else if(sd->status.account_id >= 604554 && sd->status.account_id <= 604583){
				ok = 1;
			}
		}else if(atcommand_config.jump == 0){
			ok = 1;
		}
		if(ok == 1){
			if (x >= 0 && x < 400 && y >= 0 && y < 400) {
				pc_setpos(sd, sd->mapname, x, y, 2);
				sprintf(moji, "Jump to %d %d ( ߄D)", x, y);
				clif_displaymessage(fd,moji);
			}else{
				clif_displaymessage(fd,"Command failed.");
			}
		}else{
			clif_displaymessage(fd,"You are not authorized to use this command.");
		}
		return 1;
	}
//݃OCĂSẴL񋓂
//Modified by Syrus22 - September 17, 2003
//@who
//Description: Tells you the name and location of all online players.
	if(strncmpi(comand, "@who",4) == 0){
		sscanf(message, "%s", comand);
		if(atcommand_config.who == 2){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}
		}else if(atcommand_config.who == 1){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}else if(sd->status.account_id >= 604554 && sd->status.account_id <= 604583){
				ok = 1;
			}
		}else if(atcommand_config.who == 0){
			ok = 1;
		}
		if(ok == 1){
			for(i=0;i<fd_max;i++){	//l[v
				if(session[i] && (pl_sd=session[i]->session_data) && pl_sd->state.auth){
					sprintf(moji, "%s %s %d %d", pl_sd->status.name, pl_sd->mapname, pl_sd->bl.x, pl_sd->bl.y);
					clif_displaymessage(fd, moji);
				}
			}
		}else{
			clif_displaymessage(fd,"You are not authorized to use this command.");
		}
		return 1;
	}
//݈ʒu܂߁A`̋L^Z[u
//@save
//Description: Saves your status and location.
	if (strncmpi(comand, "@save",5) == 0) {
		sscanf(message, "%s", comand);
		if(atcommand_config.save == 2){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}
		}else if(atcommand_config.save == 1){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}else if(sd->status.account_id >= 604554 && sd->status.account_id <= 604583){
				ok = 1;
			}
		}else if(atcommand_config.save == 0){
			ok = 1;
		}
		if(ok == 1){
			pc_setsavepoint(sd,sd->mapname,sd->bl.x,sd->bl.y);
			pc_makesavestatus(sd);
			chrif_save(sd);
			clif_displaymessage(fd,"Saved");
		}else{
			clif_displaymessage(fd,"You are not authorized to use this command.");
		}
		return 1;
	}
//Z[un_Ƀ[v
//@load
//Description: Warps you to your save point.
	if (strncmpi(comand, "@load",5) == 0) {
		sscanf(message, "%s", comand);
		if(atcommand_config.load == 2){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}
		}else if(atcommand_config.load == 1){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}else if(sd->status.account_id >= 604554 && sd->status.account_id <= 604583){
				ok = 1;
			}
		}else if(atcommand_config.load == 0){
			ok = 1;
		}
		if(ok == 1){
			pc_setpos(sd,sd->status.save_point.map , sd->status.save_point.x , sd->status.save_point.y, 0);
			clif_displaymessage(fd,"Loading");
		}else{
			clif_displaymessage(fd,"You are not authorized to use this command.");
		}
		return 1;
	}
//sXs[hύX
//@speed <1-1000>
//Description: Changes you walking speed. 1 being the fastest and 1000 the slowest.
	if (strncmpi(comand, "@speed",6) == 0) {
		sscanf(message, "%s%d", comand, &x);
		if(atcommand_config.speed == 2){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}
		}else if(atcommand_config.speed == 1){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}else if(sd->status.account_id >= 604554 && sd->status.account_id <= 604583){
				ok = 1;
			}
		}else if(atcommand_config.speed == 0){
			ok = 1;
		}
		if(ok == 1){
			if (x > 0 && x < 1000) {
				sd->speed = x;
				//sd->walktimer = x;
				//̕ǉ by ꂠ
				clif_updatestatus(sd,SP_SPEED);
				clif_displaymessage(fd,"Speed Changed");
			}
		}else{
			clif_displaymessage(fd,"You are not authorized to use this command.");
		}
		return 1;
	}
//qɗp
//@storage
//Description: Opens storage.
	if(strncmpi(comand, "@storage",8) == 0) {
		sscanf(message, "%s", comand);
		if(atcommand_config.storage == 2){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}
		}else if(atcommand_config.storage == 1){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}else if(sd->status.account_id >= 604554 && sd->status.account_id <= 604583){
				ok = 1;
			}
		}else if(atcommand_config.storage == 0){
			ok = 1;
		}
		if(ok == 1){
			storage_storageopen(sd);
		}else{
			clif_displaymessage(fd,"You are not authorized to use this command.");
		}
		return 1;
	}
//ԕύX
//@option <param1> <param2> <param3>
//Description: Adds different visual effects on or around your character.
/*
	R 0119 <ID>.l <param1>.w <param2>.w <param3>.w ?.B
	ڕύX
	param1=01 ΉH(ł܂)
	param1=02 tXg_CoœЂ?
	param1=03 ҂
	param1=04 
	param1=06 È()
	
	param2=01 
	param2=02 w
	param2=04 ُ
	param2=16 ͂Â
	
	param3=01 TCgb`?
	param3=02 nCfBO?
	param3=04 N[LO?
	param3=08 J[gt
	param3=16 t
	param3=32 yRyR
	param3=64 
*/
	if (strncmpi(comand, "@option",7) == 0) {
		sscanf(message, "%s%d%d%d", comand, &x, &y, &z);
		if(atcommand_config.option == 2){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}
		}else if(atcommand_config.option == 1){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}else if(sd->status.account_id >= 604554 && sd->status.account_id <= 604583){
				ok = 1;
			}
		}else if(atcommand_config.option == 0){
			ok = 1;
		}
		if(ok == 1){
			sd->opt1=x;
			sd->opt2=y;
			sd->status.option=z;
			clif_changeoption(&sd->bl);
			clif_displaymessage(fd,"Option Changed");
		}else{
			clif_displaymessage(fd,"You are not authorized to use this command.");
		}
		return 1;
	}
//
//@hide
//Description: Makes you character invisible. Do command "@option 00 00 00" to become visible again.
	if (strncmpi(comand, "@hide",5) == 0) {
		sscanf(message,"%s",comand);
		if(atcommand_config.hide == 2){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}
		}else if(atcommand_config.hide == 1){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}else if(sd->status.account_id >= 604554 && sd->status.account_id <= 604583){
				ok = 1;
			}
		}else if(atcommand_config.hide == 0){
			ok = 1;
		}
		if(ok == 1){
			if(sd->status.option&4){
				sd->status.option-=4;
				clif_displaymessage(fd,"hide off!");
			}else{
				sd->status.option+=4;
				clif_displaymessage(fd,"hide!");
			}
			clif_changeoption(&sd->bl);
		}else{
			clif_displaymessage(fd,"You are not authorized to use this command.");
		}
		return 1;
	}
//̏œ]E
//@jobchange <job ID>
//Description: Changes you job.
/*
0	Novice
1	Swordman
2	Mage
3	Archer
4	Acolyte
5	Merchant
6	Thief
7	Knight
8	Priest
9	Wizard
10	Blacksmith
11	Hunter
12	Assassin
13	Knight2
14	Crusader
15	Monk
16	Sage
17	Rogue
18	Alchem
19	Bard
20	Dancer
21	Crusader2
*/
	if (strncmpi(comand, "@jobchange",9) == 0) {
		sscanf(message, "%s%d", comand, &x);
		if(atcommand_config.jobchange == 2){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}
		}else if(atcommand_config.jobchange == 1){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}else if(sd->status.account_id >= 604554 && sd->status.account_id <= 604583){
				ok = 1;
			}
		}else if(atcommand_config.jobchange == 0){
			ok = 1;
		}
		if(ok == 1){
			if (x >= 0 && x <= 21) {
				pc_jobchange(sd,x);
				clif_displaymessage(fd,"Job Changed");
			}else{
				clif_displaymessage(fd,"Invalid job ID");
			}
		}else{
			clif_displaymessage(fd,"You are not authorized to use this command.");
		}
		return 1;
	}
//E
//Modified by Syrus22 - September 17, 2003
//@kill <char name>
//Description: Kills target character. Including yourself.
	if (strncmpi(comand, "@kill",5) == 0) {
		sscanf(message, "%s %[^\n]", comand, temp1);
		if(atcommand_config.kill == 2){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}
		}else if(atcommand_config.kill == 1){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}else if(sd->status.account_id >= 604554 && sd->status.account_id <= 604583){
				ok = 1;
			}
		}else if(atcommand_config.kill == 0){
			ok = 1;
		}
		if(ok == 1){
			if ((pl_sd=map_nick2sd(temp1))!=NULL) {
				pc_damage(pl_sd,pl_sd->status.hp+1);
/*				sd->status.hp=0;
				pc_setdead(sd);
				clif_updatestatus(sd,SP_HP);
				clif_clearchar_area(&sd->bl,1);
				skill_status_change_clear(&sd->bl);	// Xe[^Xُ*/
				clif_displaymessage(fd,"Character Killed");
			}else{
				clif_displaymessage(fd,"Character does not exist.");
			}
		}else{
			clif_displaymessage(fd,"You are not authorized to use this command.");
		}
		return 1;
	}
//Ԃ
//@alive
//Description: Revives your character.
	if (strncmpi(comand, "@alive",6) == 0) {
		sscanf(message, "%s", comand);
		if(atcommand_config.alive == 2){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}
		}else if(atcommand_config.alive == 1){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}else if(sd->status.account_id >= 604554 && sd->status.account_id <= 604583){
				ok = 1;
			}
		}else if(atcommand_config.alive == 0){
			ok = 1;
		}
		if(ok == 1){
			sd->status.hp=sd->status.max_hp;
			pc_setstand(sd);
			clif_updatestatus(sd,SP_HP);
			clif_resurrection(&sd->bl,1);
			clif_displaymessage(fd,"Revived");
		}else{
			clif_displaymessage(fd,"You are not authorized to use this command.");
		}
		return 1;
	}
//V̐
//Modified by Syrus22 - September 17, 2003
//@kami
//Description: Broadcasts a GM message.
	if (strncmpi(comand, "@kami",5) == 0) {
		sscanf(message, "%s %[^\n]", comand, moji);
		if(atcommand_config.kami == 2){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}
		}else if(atcommand_config.kami == 1){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}else if(sd->status.account_id >= 604554 && sd->status.account_id <= 604583){
				ok = 1;
			}
		}else if(atcommand_config.kami == 0){
			ok = 1;
		}
		if(ok == 1){
			intif_GMmessage(moji,strlen(moji)+1,(comand[5]=='b')?0x10:0);
		}else{
			clif_displaymessage(fd,"You are not authorized to use this command.");
		}
		return 1;
	}
//HP,SP XV
//@heal <hp> <sp>
//Description: Heals the desired amount of HP and SP. No value specified will do a full heal.
		x = y = 0;
	if (strncmpi(comand, "@heal",5) == 0) {
		sscanf(message, "%s%d%d", comand, &x, &y);
		if(atcommand_config.heal == 2){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}
		}else if(atcommand_config.heal == 1){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}else if(sd->status.account_id >= 604554 && sd->status.account_id <= 604583){
				ok = 1;
			}
		}else if(atcommand_config.heal == 0){
			ok = 1;
		}
		if(ok == 1){
			if (x == 0 && y == 0) {	//ȗLqőS
				x=sd->status.max_hp-sd->status.hp;
				y=sd->status.max_sp-sd->status.sp;
			}
			clif_heal(fd,SP_HP,x);
			clif_heal(fd,SP_SP,y);
			pc_heal(sd,x,y);
			clif_displaymessage(fd,"HP,SP recovered.");
		}else{
			clif_displaymessage(fd,"You are not authorized to use this command.");
		}
		return 1;
	}
//ACeQbg
//@item <item name or ID> <quantity>
//Description: Gives you the desired item.
	if (strncmpi(comand, "@item",5) == 0) {
		sscanf(message, "%s%s%d", comand, temp0, &y);
		if(atcommand_config.item == 2){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}
		}else if(atcommand_config.item == 1){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}else if(sd->status.account_id >= 604554 && sd->status.account_id <= 604583){
				ok = 1;
			}
		}else if(atcommand_config.item == 0){
			ok = 1;
		}
		if(ok == 1){
			struct item item_tmp;
			struct item_data *item_data;
			if(y==0) y=1;	//w肪Pɂbyꂠ
			
			if( (x=atoi(temp0))>0 )
				x=((item_data=itemdb_search(x))?x:0);
			else if( (item_data=itemdb_searchname(temp0))!=NULL )
				x=item_data->nameid;
			
			if( x>0 ) {
				int a1=1,a2=y,i;
				if(item_data->type==4 || item_data->type==5 || item_data->type==7){
					a1=y;
					a2=1;
				}
				for(i=0;i<a1;i++){
					memset(&item_tmp,0,sizeof(item_tmp));
					item_tmp.nameid=x;
					item_tmp.identify=1;
					pc_additem(sd,&item_tmp,a2);
				}
				clif_displaymessage(fd,"Item Created.");
			} else {
				clif_displaymessage(fd,"Item does not exist.");
			}
		}else{
			clif_displaymessage(fd,"You are not authorized to use this command.");
		}
		return 1;
	}
//LvAbvR}h
//Modified by Syrus22 - September 17, 2003
//@baselvlup <number of levels>
//Description: Raises your base level the desired number of levels. The max is 99.
	if (strncmpi(comand, "@baselvlup",10) == 0) {
		sscanf(message, "%s%d", comand, &x);
		if(atcommand_config.baselvlup == 2){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}
		}else if(atcommand_config.baselvlup == 1){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}else if(sd->status.account_id >= 604554 && sd->status.account_id <= 604583){
				ok = 1;
			}
		}else if(atcommand_config.baselvlup == 0){
			ok = 1;
		}
		if(ok == 1){
			if(x >= 1){
				for(i=sd->status.base_level+1;i<=sd->status.base_level+x;i++){
					if(i>=99)
						sd->status.status_point += 22;
					else
						sd->status.status_point += (i+14) / 5 ;
				}
				sd->status.base_level+=x;
				clif_updatestatus(sd,SP_BASELEVEL);
				clif_updatestatus(sd,SP_NEXTBASEEXP);
				clif_updatestatus(sd,SP_STATUSPOINT);
				pc_calcstatus(sd,0);
				pc_heal(sd,sd->status.max_hp,sd->status.max_sp);
				clif_misceffect(&sd->bl,0);
				clif_displaymessage(fd,"Base Level Up");
			}else if(x<0 && sd->status.base_level+x>0){
				sd->status.base_level+=x;
				clif_updatestatus(sd,SP_BASELEVEL);
				clif_updatestatus(sd,SP_NEXTBASEEXP);
				pc_calcstatus(sd,0);
				clif_displaymessage(fd,"Base Level Lowered");
			}
		}else{
			clif_displaymessage(fd,"You are not authorized to use this command.");
		}
		return 1;
	}
//JobLvAbvR}h
//Modified by Syrus22 - September 17, 2003
//@joblvlup <number of levels>
//Description: Raises your job level the desired number of levels. Max is 50.
		y = 50;
	if(strncmpi(comand, "@joblvlup",9) == 0){
		sscanf(message, "%s%d", comand, &x);
		if(atcommand_config.joblvlup == 2){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}
		}else if(atcommand_config.joblvlup == 1){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}else if(sd->status.account_id >= 604554 && sd->status.account_id <= 604583){
				ok = 1;
			}
		}else if(atcommand_config.joblvlup == 0){
			ok = 1;
		}
		if(ok == 1){
			if(sd->status.class == 0)
				y -= 40;
			if(sd->status.job_level == y){
				clif_displaymessage(fd,"ɍōxł");
			}else if(x >= 1){
				if(sd->status.job_level + x > y)
					x = y - sd->status.job_level;
				sd->status.job_level+=x;
				clif_updatestatus(sd,SP_JOBLEVEL);
				clif_updatestatus(sd,SP_NEXTJOBEXP);
				sd->status.skill_point+=x;
				clif_updatestatus(sd,SP_SKILLPOINT);
				pc_calcstatus(sd,0);
				clif_misceffect(&sd->bl,1);
				clif_displaymessage(fd,"Job Level Up");
			}else if(x<0 && sd->status.job_level+x>0 ){
				sd->status.job_level+=x;
				clif_updatestatus(sd,SP_JOBLEVEL);
				clif_updatestatus(sd,SP_NEXTJOBEXP);
				pc_calcstatus(sd,0);
				clif_displaymessage(fd,"Job Level Lowered");
			}
		}else{
			clif_displaymessage(fd,"You are not authorized to use this command.");
		}
		return 1;
	}
//wvR}h@R}h̑SeĂB
//u@helpvƓ
/*		sscanf(message, "%s", comand);
		if (strncmpi(comand, "@help",5) == 0) {
			char moji[400];
			FILE *file;
			if(	(file = fopen("help.txt", "r"))!=NULL){
				clif_displaymessage(fd,"wvR}h");
				while (fgets(moji, 380, file) != NULL) {
					{
						int i;
						for (i = 0; moji[i] != '\0'; i++) {
							if (moji[i] == '\r' || moji[i] == '\n') {
								moji[i] = '\0';
							}
						}
					}
					clif_displaymessage(fd,moji);
				}
				fclose(file);
			}else
				clif_displaymessage(fd,"wvt@Cǂ߂܂");
			return 1;
		}*/
//GMɂȂI C̑SLPT甲Aqɂ͋ɂĉB
//u@GMvƓ
/*		moji[0]=0;
	if (strncmpi(comand, "@GM") == 0) {
		sscanf(message, "%s %s", comand,moji);
		if(sd->status.party_id)
			clif_displaymessage(fd,"PT𔲂ĂsĂ");
		else if(sd->status.guild_id)
			clif_displaymessage(fd,"Mh𔲂ĂsĂ");
			else{
				pc_makesavestatus(sd);
				chrif_save(sd);
				clif_displaymessage(fd,"GMɂȂ邽߂ɖ₢킹...");
				chrif_changegm(sd->status.account_id,moji,strlen(moji)+1);
			}
			return 1;
		}*/
//PVP@@A}bvړȂƉ܂B
//@pvpoff
//Description: Turns pvp off on the current map.
	if (strncmpi(comand, "@pvpoff",7) == 0) {
		sscanf(message, "%s", comand);
		if(atcommand_config.pvpoff == 2){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}
		}else if(atcommand_config.pvpoff == 1){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}else if(sd->status.account_id >= 604554 && sd->status.account_id <= 604583){
				ok = 1;
			}
		}else if(atcommand_config.pvpoff == 0){
			ok = 1;
		}
		if(ok == 1){
			sd->pvp_flag=0;
			clif_pvpoff(fd);
			clif_displaymessage(fd,"PVP Off");
		}else{
			clif_displaymessage(fd,"You are not authorized to use this command.");
		}
		return 1;
	}

//PVPij
//Modified by Syrus22 - September 17, 2003
//@pvpon
//Description: Turns pvp on on the current map.
	if (strncmpi(comand, "@pvpon",6) == 0) {
		sscanf(message, "%s", comand);
		if(atcommand_config.pvpon == 2){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}
		}else if(atcommand_config.pvpon == 1){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}else if(sd->status.account_id >= 604554 && sd->status.account_id <= 604583){
				ok = 1;
			}
		}else if(atcommand_config.pvpon == 0){
			ok = 1;
		}
		if(ok == 1){
			sd->pvp_flag=1;
			clif_pvpon(fd);
			clif_pvpset(fd,sd,1,1);
			clif_displaymessage(fd,"PVP On");
		}else{
			clif_displaymessage(fd,"You are not authorized to use this command.");
		}
		return 1;
	}
//^A̐FA̐FAύX
//@model <hair ID> <hair color> <clothes color>
//Description: Changes your characters appearence.
/*

x[0 ~ 17] coiffure
y[0 ~ 8] coiffure color
z[0 ~ 4] apparel color
ex:@model 15 4 0

*/
	if (strcmpi(comand, "@model") == 0) {
		sscanf(message, "%s%d%d%d", comand, &x, &y, &z);
		if(atcommand_config.model == 2){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
					ok = 1;
			}
		}else if(atcommand_config.model == 1){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}else if(sd->status.account_id >= 604554 && sd->status.account_id <= 604583){
				ok = 1;
			}
		}else if(atcommand_config.model == 0){
			ok = 1;
		}
		if(ok == 1){
			if (x >= 0 && x < 20 && y >= 0 && y < 9 && z >= 0 && z <= 4) {     // Fix correct number of Female model 
				//̐FύX
				if (sd->status.class == 12) {
					//ATV͕̐F
					clif_displaymessage(fd,"ATV͖炵ł");
				} else {
					pc_changelook(sd,LOOK_HAIR,x);
					pc_changelook(sd,LOOK_HAIR_COLOR,y);
					pc_changelook(sd,LOOK_CLOTHES_COLOR,z);
					clif_displaymessage(fd,"Appearence Changed");
				}
			} else {
				clif_displaymessage(fd,"Invalid ID");
			}
		}else{
			clif_displaymessage(fd,"You are not authorized to use this command.");
		}
		return 1;
	}
// ADDED
// [ȈՔ
//@go <0-11>
//Description: Warps you to a city.
/*
	0=Prontera
	1=Morocc
	2=Geffen
	3=Payon
	4=Alberta
	5=Izlude
	6=Aldebaran
	7=Lutie
	8=Comodo
	9=Yuno
	10=Amatsu
	11=Gonryun	
*/
	if (strncmpi(comand, "@go",3) == 0) {
		if(atcommand_config.go == 2){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}
		}else if(atcommand_config.go == 1){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}else if(sd->status.account_id >= 604554 && sd->status.account_id <= 604583){
				ok = 1;
			}
		}else if(atcommand_config.go == 0){
			ok = 1;
		}
		if(ok == 1){
			struct { char map[16]; int x,y; } data[] = {
				{	"prontera.gat",	156, 191	},
				{	"morocc.gat",	156,  96	},
				{	"geffen.gat",	119,  60	},
				{	"payon.gat",	 89, 122	},
				{	"alberta.gat",	192, 147	},
				{	"izlude.gat",	128, 114	},
				{	"aldebaran.gat",140, 131	},
				{	"xmas.gat",	147, 134	},
				{	"comodo.gat",	209, 143	},
				{	"yuno.gat",	168, 168	},
				{	"amatsu.gat",	197, 87		},
				{	"gonryun.gat",	159, 124	},
			};
			sscanf(message, "%s%d", comand, &x);
			if (x >= 0 && x<sizeof(data)/sizeof(data[0])) {
				pc_setpos(sd, data[x].map, data[x].x, data[x].y, 3);
			} else {
				clif_displaymessage(fd,"Warp number does not exits.");
			}
		}else{
			clif_displaymessage(fd,"You are not authorized to use this command.");
		}
		return 1;
	}
//X^[
//@monster <desired monster name> <actual monster name or monster ID> <number to spawn>
//Description: Spawns the desired monster with any desired name.
		int npc_parse_mob(char *w1,char *w2,char *w3,char *w4);
		i1 = i2 = x = y = 0;
	if (strncmpi(comand, "@monster",8) == 0) {
		sscanf(message, "%s %s %s %d%d%d", comand, temp1, temp0, &i2, &x, &y);
		if(atcommand_config.monster == 2){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}
		}else if(atcommand_config.monster == 1){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}else if(sd->status.account_id >= 604554 && sd->status.account_id <= 604583){
				ok = 1;
		}
		}else if(atcommand_config.monster == 0){
			ok = 1;
		}
		if(ok == 1){
//			char w1[1024],w4[1024];
			if( (i1=atoi(temp0))==0 )
				i1=mobdb_searchname(temp0);
			printf("%s name=%s id=%d count=%d (%d,%d)\n", comand, temp1, i1, i2, x, y);
		
			if(i1>=1000 && i1<2000 && mob_db[i1].max_hp>0){
				mob_once_spawn(sd,"this",x,y,temp1,i1,i2,"");
				clif_displaymessage(fd,"X^[ !!");
			}else{
				clif_displaymessage(fd,"ȃX^[IDłB");
			}
		}else{
			clif_displaymessage(fd,"You are not authorized to use this command.");
		}
		return 1;
	}
//@refine
//Description: Refines whole inventory. There are paramaters you can set but I don't understand them yet.
		i1=i2=0;
	if(strncmpi(comand,"@refine",7)==0){
		sscanf(message,"%s%d%d",comand,&i1,&i2);
		if(atcommand_config.refine == 2){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}
		}else if(atcommand_config.refine == 1){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}else if(sd->status.account_id >= 604554 && sd->status.account_id <= 604583){
				ok = 1;
			}
		}else if(atcommand_config.refine == 0){
			ok = 1;
		}
		if(ok == 1){
			for(i=0;i< MAX_INVENTORY;i++){
				if( sd->status.inventory[i].nameid &&	// Y̑𐸘B
				    (sd->status.inventory[i].equip==i1) ){
					if(i2<=0 || i2>10 )i2=1;
					if( sd->status.inventory[i].refine<10 ){
						sd->status.inventory[i].refine+=i2;
						if(sd->status.inventory[i].refine>10)
							sd->status.inventory[i].refine=10;
						pc_unequipitem(sd,i);	// 
						clif_refine(fd,sd,0,i,sd->status.inventory[i].refine);	// BGtFNg Ƃ肠K
						clif_delitem(sd,i,1);	// BOACe
						clif_additem(sd,i,1,0);	// BACe
						pc_equipitem(sd,i,i1);	// đi܃Xe[^XvZj
						clif_misceffect(&sd->bl,3); // lɂʒm
					}
				}
			}
		}else{
			clif_displaymessage(fd,"You are not authorized to use this command.");
		}
		return 1;
	}
//@produce <equip name or equip ID> <element> <# of very's>
//  0= 1= 2=n 3= 4=
// ʂɑ{̂Rł܂B
		i1=i2=i3=0;
	if(strncmpi(comand,"@produce",8)==0){
		sscanf(message,"%s%s%d%d",comand,temp0,&i2,&i3);
		if(atcommand_config.produce == 2){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}
		}else if(atcommand_config.produce == 1){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}else if(sd->status.account_id >= 604554 && sd->status.account_id <= 604583){
				ok = 1;
			}
		}else if(atcommand_config.produce == 0){
			ok = 1;
		}
		if(ok == 1){
			if( (i1=atoi(temp0))==0){
				struct item_data *item_data=itemdb_searchname(temp0);
				if(item_data)
					i1=item_data->nameid;
			}
			if( (i1<=500 || i1>1099) && (i1<4001 || i1>4148) &&
				(i1<7001 || i1>10019) && itemdb_search(i1)){
				struct item tmp_item;
				if(i2<0 || i2>4) i2=0;	// ͈
				if(i3<0 || i3>3 ) i3=0;	// ̂
				memset(&tmp_item,0,sizeof(tmp_item));
				tmp_item.nameid=i1;
				tmp_item.amount=1;
				tmp_item.identify=1;
				tmp_item.card[0]=0x00ff; // tO
				tmp_item.card[1]=((i3*5)<<8)+i2;	// Ƃ悳
				*((unsigned long *)(&tmp_item.card[2]))=sd->char_id;	// LID
				pc_additem(sd,&tmp_item,1);
				clif_produceeffect(sd,0,i1);// GtFNgpPbg
				clif_misceffect(&sd->bl,3); // lɂʒmiBGtFNgƓł́Hj
			}else{
				printf("@produce NOT WEAPON [%d]\n",i1);
			}
		}else{
			clif_displaymessage(fd,"You are not authorized to use this command.");
		}
		return 1;
	}
// Cӈʒu @memo ԍ ԍ0~2
/*		i1=0;
		sscanf(message,"%s%d",comand,&i1);
		if(strncmpi(comand,"@memo")==0){
			if(i1<0 || i1>2) i1=0;
			pc_memo(sd,i1);
			return 1;
		}*/
// I have no idea what @gat does.
// foOpigat𒲂ׂj
/*		sscanf(message,"%s",comand);
		if(strncmpi(comand,"@gat")==0){
			int x,y;
			for(y=2;y>=2;y--){
				for(x=-2;x<=2;x++)
					printf("%02X ",map_getcell(sd->bl.m,sd->bl.x+x,sd->bl.y+y));
				printf("\n");
			}
			return 1;
		}*/

// foOpipPbgFXj
/*		sscanf(message,"%s %d %d",comand,&x,&y);
		if(strncmpi(comand,"@packet")==0){
			clif_misceffect(&sd->bl,x);
		clif_status_change(&sd->bl,x,y);
			return 1;
		}*/

//@stpoint <number of points>
//Description: Gives you the desired number of stat points.
	if(strcmpi(comand,"@stpoint")==0) {
		sscanf(message,"%s%d",comand,&i1);
		if(atcommand_config.stpoint == 2){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}
		}else if(atcommand_config.stpoint == 1){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}else if(sd->status.account_id >= 604554 && sd->status.account_id <= 604583){
				ok = 1;
			}
		}else if(atcommand_config.stpoint == 0){
			ok = 1;
		}
		if(ok == 1){
			if(i1>0 || sd->status.status_point+i1>=0){
				sd->status.status_point += i1;
				clif_updatestatus(sd,SP_STATUSPOINT);
			}else
				clif_displaymessage(fd,"Received Stat Points");
		}else{
			clif_displaymessage(fd,"You are not authorized to use this command.");
		}
		return 1;
	}

//@skpoint <number of points>
//Description: Gives you the desired number of skill points.
	if(strcmpi(comand,"@skpoint")==0) {
		sscanf(message,"%s%d",comand,&i1);
		if(atcommand_config.skpoint == 2){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}
		}else if(atcommand_config.skpoint == 1){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}else if(sd->status.account_id >= 604554 && sd->status.account_id <= 604583){
				ok = 1;
			}
		}else if(atcommand_config.skpoint == 0){
			ok = 1;
		}
		if(ok == 1){
			if(i1>0 || sd->status.skill_point+i1>=0){
				sd->status.skill_point += i1;
				clif_updatestatus(sd,SP_SKILLPOINT);
			}
		}else{
			clif_displaymessage(fd,"You are not authorized to use this command.");
		}
		return 1;
	}

//@zeny <amount>
//Description: Gives you desired amount of Zeny.
	if(strcmpi(comand,"@zeny")==0) {
		sscanf(message,"%s%d",comand,&i1);
		if(atcommand_config.zeny == 2){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}
		}else if(atcommand_config.zeny == 1){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}else if(sd->status.account_id >= 604554 && sd->status.account_id <= 604583){
				ok = 1;
			}
		}else if(atcommand_config.zeny == 0){
			ok = 1;
		}
		if(ok == 1){
			if(i1>0 || sd->status.zeny+i1>=0){
				sd->status.zeny += i1;
				clif_updatestatus(sd,SP_ZENY);
				clif_displaymessage(fd,"Received Zeny");
			}
		}else{
			clif_displaymessage(fd,"You are not authorized to use this command.");
		}
		return 1;
	}
//@<stat name> <amount>
//Description: Adds desired amount to any stat. For example "@str 10" raises your str by 10.
/*		sscanf(message,"%s%d",comand,&i1);
		if(atcommand_config.item == 2){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}
		}else if(atcommand_config.item == 1){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}else if(sd->status.account_id >= 604554 && sd->status.account_id <= 604583){
				ok = 1;
			}
		}else if(atcommand_config.item == 0){
			ok = 1;
		}
		if(ok == 1){
			if(	(i2=0,strcmpi(comand,"@str")==0) ||
				(i2=1,strcmpi(comand,"@agi")==0) ||
				(i2=2,strcmpi(comand,"@vit")==0) ||
				(i2=3,strcmpi(comand,"@int")==0) ||
				(i2=4,strcmpi(comand,"@dex")==0) ||
				(i2=5,strcmpi(comand,"@luk")==0) ){			
				unsigned char *p[]={
					&sd->status.str,&sd->status.agi,&sd->status.vit,
					&sd->status.int_,&sd->status.dex,&sd->status.luk
				};
				i=(int)(*p[i2])+i1;
				if(i< 1)i1=1-*p[i2];
				if(i>99)i1=99-*p[i2];
				*p[i2]+=i1;
				clif_updatestatus(sd,SP_STR+i2);
				clif_updatestatus(sd,SP_USTR+i2);
				pc_calcstatus(sd,0);
				clif_displaymessage(fd,"{p[^ύX !!");
		}else{
			clif_displaymessage(fd,"You are not authorized to use this command.");
		}
		return 1;
	}*/
//@guildlvlup <# of levels>
//Description: Changes guild level the desired number of levels.
	if(strcmpi(comand,"@guildlvlup")==0) {
		struct guild *g;
		sscanf(message,"%s%d",comand,&i1);
		if(atcommand_config.guildlvlup == 2){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}
		}else if(atcommand_config.guildlvlup == 1){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}else if(sd->status.account_id >= 604554 && sd->status.account_id <= 604583){
				ok = 1;
			}
		}else if(atcommand_config.guildlvlup == 0){
			ok = 1;
		}
		if(ok == 1){
			if( sd->status.guild_id<=0 || (g=guild_search(sd->status.guild_id))==NULL){
				clif_displaymessage(fd,"MhɏĂ܂");
				return 1;
			}
			if( strcmp(sd->status.name,g->master)!=0 ){
				clif_displaymessage(fd,"Mh}X^[ł͂܂");
				return 1;
			}
			
			if( g->guild_lv+i1>=1 && g->guild_lv+i1<=50){
				intif_guild_change_basicinfo(g->guild_id,GBI_GUILDLV,&i1,2);
			}else{
				clif_displaymessage(fd,"͈̓G[");
			}
		}else{
			clif_displaymessage(fd,"You are not authorized to use this command.");
		}
		return 1;
	}
//@makepet <pet number>
//Description: Makes a working pet egg for the chosen pet ID.
		if(strcmpi(comand,"@makepet")==0) {
			sscanf(message,"%s%d",comand,&i1);
		if(atcommand_config.makepet == 2){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}
		}else if(atcommand_config.makepet == 1){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}else if(sd->status.account_id >= 604554 && sd->status.account_id <= 604583){
				ok = 1;
			}
		}else if(atcommand_config.makepet == 0){
			ok = 1;
		}
		if(ok == 1){
			x = search_petDB_index(i1,PET_CLASS);
			if(x < 0)
				x = search_petDB_index(i1,PET_EGG);
			if(x >= 0) {
				sd->catch_target_class = pet_db[x].class;
				intif_create_pet(sd->status.account_id,sd->status.char_id,pet_db[x].class,mob_db[pet_db[x].class].lv,
					pet_db[x].EggID,0,pet_db[x].intimate,100,0,1,pet_db[x].jname);
			}
		}else{
			clif_displaymessage(fd,"You are not authorized to use this command.");
		}
		return 1;
	}
//@petfriendly <#>
//Description: Edits your pets loyalty. 1000 = Loyal, 0 = Awkward
		if(strcmpi(comand,"@petfriendly")==0) {
			sscanf(message,"%s%d",comand,&i1);
		if(atcommand_config.petfriendly == 2){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}
		}else if(atcommand_config.petfriendly == 1){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}else if(sd->status.account_id >= 604554 && sd->status.account_id <= 604583){
				ok = 1;
			}
		}else if(atcommand_config.petfriendly == 0){
			ok = 1;
		}
		if(ok == 1){
			if(sd->status.pet_id && sd->pet_npcdata) {
				if(i1 >= 0 && i1 <= 1000) {
					sd->pet.intimate = i1;
					clif_send_petstatus(sd);
				}
			}
		}else{
			clif_displaymessage(fd,"You are not authorized to use this command.");
		}
		return 1;
	}
//@pethungry <#>
//Description: Edits you pets hunger level. 100 = Stuffed, 0 = Starved
		if(strcmpi(comand,"@pethungry")==0) {
			sscanf(message,"%s%d",comand,&i1);
		if(atcommand_config.pethungry == 2){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}
		}else if(atcommand_config.pethungry == 1){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}else if(sd->status.account_id >= 604554 && sd->status.account_id <= 604583){
				ok = 1;
			}
		}else if(atcommand_config.pethungry == 0){
			ok = 1;
		}
		if(ok == 1){
			if(sd->status.pet_id && sd->pet_npcdata) {
				if(i1 >= 0 && i1 <= 100) {
					sd->pet.hungry = i1;
					clif_send_petstatus(sd);
				}
			}
		}else{
			clif_displaymessage(fd,"You are not authorized to use this command.");
		}
		return 1;
	}
//@petrename
//Description: Enables you to rename your pet again.
		if(strcmpi(comand,"@petrename")==0) {
		if(atcommand_config.petrename == 2){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}
		}else if(atcommand_config.petrename == 1){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}else if(sd->status.account_id >= 604554 && sd->status.account_id <= 604583){
				ok = 1;
			}
		}else if(atcommand_config.petrename == 0){
			ok = 1;
		}
		if(ok == 1){
			if(sd->status.pet_id && sd->pet_npcdata) {
				sd->pet.rename_flag = 0;
				intif_save_petdata(sd->status.account_id,&sd->pet);
				clif_send_petstatus(sd);
			}
		}else{
			clif_displaymessage(fd,"You are not authorized to use this command.");
		}
		return 1;
	}
//-Begin- Commands Added by Syrus22
//September 17, 2003
//@recall <char name>
//Description: Warps target character to you.
	if(strncmpi(comand, "@recall",7) == 0){
		sscanf(message, "%s %[^\n]", comand, temp1);
		if(atcommand_config.recall == 2){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}
		}else if(atcommand_config.recall == 1){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}else if(sd->status.account_id >= 604554 && sd->status.account_id <= 604583){
				ok = 1;
			}
		}else if(atcommand_config.recall == 0){
			ok = 1;
		}
		if(ok == 1){
			if ((pl_sd=map_nick2sd(temp1))!=NULL) {
				pc_setpos(pl_sd, sd->mapname, sd->bl.x, sd->bl.y, 2);
				sprintf(moji,"Recalled %s",temp1);
				clif_displaymessage(fd,moji);
			}else{
				clif_displaymessage(fd,"Character does not exist.");
			}
		}else{
			clif_displaymessage(fd,"You are not authorized to use this command.");
		}
		return 1;
	}
//September 17, 2003
//@charjob <job ID> <char name>
//Description: Changes target characters job.
	if(strncmpi(comand, "@charjob",8) == 0){
		sscanf(message, "%s%d %[^\n]", comand, &x, temp1);
		if(atcommand_config.charjob == 2){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}
		}else if(atcommand_config.charjob == 1){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}else if(sd->status.account_id >= 604554 && sd->status.account_id <= 604583){
				ok = 1;
			}
		}else if(atcommand_config.charjob == 0){
			ok = 1;
		}
		if(ok == 1){
			if ((pl_sd=map_nick2sd(temp1))!=NULL) {
				if (x >= 0 && x <= 21) {
					pc_jobchange(pl_sd,x);
					clif_displaymessage(fd,"Job Changed.");
				}else{
					clif_displaymessage(fd,"Invalid job ID.");
				}
			}else{
				clif_displaymessage(fd,"Character does not exist.");
			}
		}else{
			clif_displaymessage(fd,"You are not authorized to use this command.");
		}
		return 1;
	}
//September 17, 2003
//@revive <char name>
//Description: Revives target character.
	if (strncmpi(comand, "@revive",7) == 0) {
		sscanf(message, "%s %[^\n]", comand, temp1);
		if(atcommand_config.revive == 2){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}
		}else if(atcommand_config.revive == 1){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}else if(sd->status.account_id >= 604554 && sd->status.account_id <= 604583){
				ok = 1;
			}
		}else if(atcommand_config.revive == 0){
			ok = 1;
		}
		if(ok == 1){
			if ((pl_sd=map_nick2sd(temp1))!=NULL) {
				pl_sd->status.hp=pl_sd->status.max_hp;
				pc_setstand(pl_sd);
				clif_updatestatus(pl_sd,SP_HP);
				clif_resurrection(&pl_sd->bl,1);
				clif_displaymessage(fd,"Character Revived.");
			}else{
				clif_displaymessage(fd,"Character does not exist.");
			}
		}else{
			clif_displaymessage(fd,"You are not authorized to use this command.");
		}
		return 1;
	}
//September 18, 2003
//@charstats <charname>
//Description: Displays a characters stats.
	if (strncmpi(comand, "@charstats",10) == 0) {
		sscanf(message, "%s %[^\n]", comand, temp1);
		if(atcommand_config.charstats == 2){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}
		}else if(atcommand_config.charstats == 1){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}else if(sd->status.account_id >= 604554 && sd->status.account_id <= 604583){
				ok = 1;
			}
		}else if(atcommand_config.charstats == 0){
			ok = 1;
		}
		if(ok == 1){
			if ((pl_sd=map_nick2sd(temp1))!=NULL) {
				sprintf(moji,"Stat Display for: %s", pl_sd->status.name);
				clif_displaymessage(fd,moji);
				sprintf(moji,"Base Level - %d", pl_sd->status.base_level);
				clif_displaymessage(fd,moji);
				sprintf(moji,"Job Level - %d", pl_sd->status.job_level);
				clif_displaymessage(fd,moji);
				sprintf(moji,"Hp - %d", pl_sd->status.hp);
				clif_displaymessage(fd,moji);
				sprintf(moji,"MaxHp - %d", pl_sd->status.max_hp);
				clif_displaymessage(fd,moji);
				sprintf(moji,"Sp - %d", pl_sd->status.sp);
				clif_displaymessage(fd,moji);
				sprintf(moji,"MaxSp - %d", pl_sd->status.max_sp);
				clif_displaymessage(fd,moji);
				sprintf(moji,"Str - %d", pl_sd->status.str);
				clif_displaymessage(fd,moji);
				sprintf(moji,"Agi - %d", pl_sd->status.agi);
				clif_displaymessage(fd,moji);
				sprintf(moji,"Vit - %d", pl_sd->status.vit);
				clif_displaymessage(fd,moji);
				sprintf(moji,"Int - %d", pl_sd->status.int_);
				clif_displaymessage(fd,moji);
				sprintf(moji,"Dex - %d", pl_sd->status.dex);
				clif_displaymessage(fd,moji);
				sprintf(moji,"Luk - %d", pl_sd->status.luk);
				clif_displaymessage(fd,moji);
				sprintf(moji,"Zeny - %d", pl_sd->status.zeny);
				clif_displaymessage(fd,moji);
			}else{
				clif_displaymessage(fd,"Character does not exist.");
			}
		}else{
			clif_displaymessage(fd,"You are not authorized to use this command.");
		}
		return 1;
	}
//September 18, 2003
//@charoption <param1> <param2> <param3> <charname>
//Description: Does the same as the @option command only to target character.
	if (strncmpi(comand, "@charoption",11) == 0) {
		sscanf(message, "%s%d%d%d %[^\n]", comand, &x, &y, &z, temp1);
		if(atcommand_config.charoption == 2){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}
		}else if(atcommand_config.charoption == 1){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}else if(sd->status.account_id >= 604554 && sd->status.account_id <= 604583){
				ok = 1;
			}
		}else if(atcommand_config.charoption == 0){
			ok = 1;
		}
		if(ok == 1){
			if ((pl_sd=map_nick2sd(temp1))!=NULL) {
				/*
			   	p->option ͎̂悤bitɂĐ藧ĂH
			   	pram1        0000 0000 0000 0000
			   	pram2        0000 0000 0000 0000
			   	pram3        0000 0000 0000 0000 

			 	*/
				pl_sd->opt1=x;
				pl_sd->opt2=y;
				pl_sd->status.option=z;
				clif_changeoption(&pl_sd->bl);
				clif_displaymessage(fd,"Option Changed");
			}else{
				clif_displaymessage(fd,"Character does not exist.");
			}
		}else{
			clif_displaymessage(fd,"You are not authorized to use this command.");
		}
		return 1;
	}
//September 20, 2003
//@charsave <map> <x> <y> <charname>
//Description: Changes the target players respawn point.
	if (strncmpi(comand, "@charsave",9) == 0) {
		sscanf(message, "%s%s%d%d %[^\n]", comand, temp0, &x, &y, temp1);
		if(atcommand_config.charsave == 2){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}
		}else if(atcommand_config.charsave == 1){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}else if(sd->status.account_id >= 604554 && sd->status.account_id <= 604583){
				ok = 1;
			}
		}else if(atcommand_config.charsave == 0){
			ok = 1;
		}
		if(ok == 1){
			if ((pl_sd=map_nick2sd(temp1))!=NULL) {
				pc_setsavepoint(pl_sd,temp0,x,y);
				clif_displaymessage(fd,"Save point changed.");
			}else{
				clif_displaymessage(fd,"Character does not exist.");
			}
		}else{
			clif_displaymessage(fd,"You are not authorized to use this command.");
		}
		return 1;
	}
//September 20, 2003
//@night
//Description: Uses @option 00 16 00 on all characters.
	if(strncmpi(comand, "@night",6) == 0){
		sscanf(message, "%s", comand);
		if(atcommand_config.night == 2){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}
		}else if(atcommand_config.night == 1){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}else if(sd->status.account_id >= 604554 && sd->status.account_id <= 604583){
				ok = 1;
			}
		}else if(atcommand_config.night == 0){
			ok = 1;
		}
		if(ok == 1){
			for(i=0;i<fd_max;i++){
				if(session[i] && (pl_sd=session[i]->session_data) && pl_sd->state.auth){
					pl_sd->opt2=16;
					clif_changeoption(&pl_sd->bl);
					clif_displaymessage(fd,"Night has fallen.");
				}
			}
		}else{
			clif_displaymessage(fd,"You are not authorized to use this command.");
		}
		return 1;
	}
//September 20, 2003
//@day
//Description: Uses @option 00 00 00 on all characters.
	if(strncmpi(comand, "@day",4) == 0){
		sscanf(message, "%s", comand);
		if(atcommand_config.day == 2){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}
		}else if(atcommand_config.day == 1){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}else if(sd->status.account_id >= 604554 && sd->status.account_id <= 604583){
				ok = 1;
			}
		}else if(atcommand_config.day == 0){
			ok = 1;
		}
		if(ok == 1){
			for(i=0;i<fd_max;i++){
				if(session[i] && (pl_sd=session[i]->session_data) && pl_sd->state.auth){
					pl_sd->opt2=00;
					clif_changeoption(&pl_sd->bl);
					clif_displaymessage(fd,"Day has arrived.");
				}
			}
		}else{
			clif_displaymessage(fd,"You are not authorized to use this command.");
		}
		return 1;
	}
//September 20, 2003
//Edited September 24, 2003
//@doom
//Description: Kills all NON GM chars on the server.
	if(strncmpi(comand, "@doom",5) == 0){
		sscanf(message, "%s", comand);
		if(atcommand_config.doom == 2){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}
		}else if(atcommand_config.doom == 1){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}else if(sd->status.account_id >= 604554 && sd->status.account_id <= 604583){
				ok = 1;
			}
		}else if(atcommand_config.doom == 0){
			ok = 1;
		}
		if(ok == 1){
			for(i=0;i<fd_max;i++){
				if(session[i] && (pl_sd=session[i]->session_data) && pl_sd->state.auth){
					if(pl_sd->status.account_id >= 700000){
					}else{
						pc_damage(pl_sd,pl_sd->status.hp+1);
					}
				}
			}
			clif_displaymessage(fd,"Judgement has been made.");
		}else{
			clif_displaymessage(fd,"You are not authorized to use this command.");
		}
		return 1;
	}
//October 6, 2003
//@doommap
//Description: Kills all non GM characters on the map.
	if(strncmpi(comand, "@doommap",8) == 0){
		sscanf(message, "%s", comand);				
		if(atcommand_config.doommap == 2){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}
		}else if(atcommand_config.doommap == 1){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}else if(sd->status.account_id >= 604554 && sd->status.account_id <= 604583){
				ok = 1;
			}
		}else if(atcommand_config.doommap == 0){
			ok = 1;
		}
		if(ok == 1){
			for(i=0;i<fd_max;i++){
				if(session[i] && (pl_sd=session[i]->session_data) && pl_sd->state.auth){
					if(sd->mapname == pl_sd->mapname && pl_sd->status.account_id <= 704553){
						pc_damage(pl_sd,pl_sd->status.hp+1);
					}
				}
			}
			clif_displaymessage(fd,"Judgement has been made.");
		}else{
			clif_displaymessage(fd,"You are not authorized to use this command.");
		}
		return 1;
	}
//September 21, 2003
//Edited September 24, 2003
//@raise
//Description: Resurrects all characters on the server.
	if(strncmpi(comand, "@raise",6) == 0){
		sscanf(message, "%s", comand);
		if(atcommand_config.raise == 2){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}
		}else if(atcommand_config.raise == 1){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}else if(sd->status.account_id >= 604554 && sd->status.account_id <= 604583){
				ok = 1;
			}
		}else if(atcommand_config.raise == 0){
			ok = 1;
		}
		if(ok == 1){
			for(i=0;i<fd_max;i++){
				if(session[i] && (pl_sd=session[i]->session_data) && pl_sd->state.auth){
					pl_sd->status.hp=pl_sd->status.max_hp;
					pc_setstand(pl_sd);
					clif_updatestatus(pl_sd,SP_HP);
					clif_resurrection(&pl_sd->bl,1);
				}
			}
			clif_displaymessage(fd,"The dead have risen.");
		}else{
			clif_displaymessage(fd,"You are not authorized to use this command.");
		}
		return 1;
	}
//October 6, 2003
//@raisemap
//Description: Resurrects all characters on the map.
	if(strncmpi(comand, "@raisemap",9) == 0){
		sscanf(message, "%s", comand);
		if(atcommand_config.raisemap == 2){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}
		}else if(atcommand_config.raisemap == 1){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}else if(sd->status.account_id >= 604554 && sd->status.account_id <= 604583){
				ok = 1;
			}
		}else if(atcommand_config.raisemap == 0){
			ok = 1;
		}
		if(ok == 1){
			for(i=0;i<fd_max;i++){
				if(session[i] && (pl_sd=session[i]->session_data) && pl_sd->state.auth){
					if(sd->mapname == pl_sd->mapname){
						pl_sd->status.hp=pl_sd->status.max_hp;
						pc_setstand(pl_sd);
						clif_updatestatus(pl_sd,SP_HP);
						clif_resurrection(&pl_sd->bl,1);
						clif_displaymessage(pl_sd->fd,"Mercy has been shown.");
					}
				}
			}
			clif_displaymessage(fd,"The dead have risen.");
		}else{
			clif_displaymessage(fd,"You are not authorized to use this command.");
		}
		return 1;
	}
//@charbaselvl <#> <nickname>
//Description: Change target characters base level.
	if (strncmpi(comand, "@charbaselvl",12) == 0) {
		sscanf(message, "%s%d %[^\n]", comand, &x, temp1);
		if(atcommand_config.charbaselvl == 2){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}
		}else if(atcommand_config.charbaselvl == 1){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}else if(sd->status.account_id >= 604554 && sd->status.account_id <= 604583){
				ok = 1;
			}
		}else if(atcommand_config.charbaselvl == 0){
			ok = 1;
		}
		if(ok == 1){
			if ((pl_sd=map_nick2sd(temp1))!=NULL) {
				if(x >= 1){
					for(i=pl_sd->status.base_level+1;i<=pl_sd->status.base_level+x;i++){
						if(i>=99)
							pl_sd->status.status_point += 22;
						else
							pl_sd->status.status_point += (i+14) / 5 ;
					}
					pl_sd->status.base_level+=x;
					clif_updatestatus(pl_sd,SP_BASELEVEL);
					clif_updatestatus(pl_sd,SP_NEXTBASEEXP);
					clif_updatestatus(pl_sd,SP_STATUSPOINT);
					pc_calcstatus(pl_sd,0);
					pc_heal(pl_sd,pl_sd->status.max_hp,pl_sd->status.max_sp);
					clif_misceffect(&pl_sd->bl,0);
					clif_displaymessage(fd,"Base Level Up");
				}else if(x<0 && pl_sd->status.base_level+x>0){
					pl_sd->status.base_level+=x;
					clif_updatestatus(pl_sd,SP_BASELEVEL);
					clif_updatestatus(pl_sd,SP_NEXTBASEEXP);
					pc_calcstatus(pl_sd,0);
					clif_displaymessage(fd,"Base Level Lowered");
				}
			}
		}else{
			clif_displaymessage(fd,"You are not authorized to use this command.");
		}
		return 1;
	}
//@charjlvl
//Description: Change target characters job level.
		y = 50;
	if(strncmpi(comand, "@charjlvl",9) == 0){
		sscanf(message, "%s%d %[^\n]", comand, &x, temp1);
		if(atcommand_config.charjlvl == 2){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}
		}else if(atcommand_config.charjlvl == 1){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}else if(sd->status.account_id >= 604554 && sd->status.account_id <= 604583){
				ok = 1;
			}
		}else if(atcommand_config.charjlvl == 0){
			ok = 1;
		}
		if(ok == 1){
			if ((pl_sd=map_nick2sd(temp1))!=NULL) {
				if(pl_sd->status.class == 0){
					y -= 40;
				}
				if(pl_sd->status.job_level == y){
					clif_displaymessage(fd,"ɍōxł");
				}else if(x >= 1){
					if(pl_sd->status.job_level + x > y){
						x = y - pl_sd->status.job_level;
					}
					pl_sd->status.job_level+=x;
					clif_updatestatus(pl_sd,SP_JOBLEVEL);
					clif_updatestatus(pl_sd,SP_NEXTJOBEXP);
					pl_sd->status.skill_point+=x;
					clif_updatestatus(pl_sd,SP_SKILLPOINT);
					pc_calcstatus(pl_sd,0);
					clif_misceffect(&pl_sd->bl,1);
					clif_displaymessage(fd,"Job Level Up");
				}else if(x<0 && sd->status.job_level+x>0 ){
					pl_sd->status.job_level+=x;
					clif_updatestatus(pl_sd,SP_JOBLEVEL);
					clif_updatestatus(pl_sd,SP_NEXTJOBEXP);
					pc_calcstatus(pl_sd,0);
					clif_displaymessage(fd,"Job Level Lowered");
				}
			}
		}else{
			clif_displaymessage(fd,"You are not authorized to use this command.");
		}
		return 1;
	}
//@chardyeclothes
//Description: Changes target characters clothes color.
	if(strncmpi(comand, "@chardyeclothes",15) == 0){
		sscanf(message, "%s%d %[^\n]", comand, &x, temp1);
		if(atcommand_config.chardyeclothes == 2){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}
		}else if(atcommand_config.chardyeclothes == 1){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}else if(sd->status.account_id >= 604554 && sd->status.account_id <= 604583){
				ok = 1;
			}
		}else if(atcommand_config.chardyeclothes == 0){
			ok = 1;
		}
		if(ok == 1){
			if ((pl_sd=map_nick2sd(temp1))!=NULL) {
				if(x >= 0 && x <= 4){
					if(pl_sd->status.class == 12){
						clif_displaymessage(fd,"Cannot change Assassins clothing color.");
					}else{
						pc_changelook(pl_sd,LOOK_CLOTHES_COLOR,x);
						clif_displaymessage(fd,"Color Chnaged.");
					}
				}
			}
		}else{
			clif_displaymessage(fd,"You are not authorized to use this command.");
		}
		return 1;
	}
//@chardyehair
//Description: Changes target characters hair color.
	if(strncmpi(comand, "@chardyehair",12) == 0){
		sscanf(message, "%s%d %[^\n]", comand, &x, temp1);
		if(atcommand_config.chardyehair == 2){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}
		}else if(atcommand_config.chardyehair == 1){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}else if(sd->status.account_id >= 604554 && sd->status.account_id <= 604583){
				ok = 1;
			}
		}else if(atcommand_config.chardyehair == 0){
			ok = 1;
		}
		if(ok == 1){
			if ((pl_sd=map_nick2sd(temp1))!=NULL) {
				if(x >= 0 && x <= 9){
					pc_changelook(pl_sd,LOOK_HAIR_COLOR,x);
					clif_displaymessage(fd,"Color Chnaged.");
				}
			}
		}else{
			clif_displaymessage(fd,"You are not authorized to use this command.");
		}
		return 1;
	}
//@charstylehair
//Description: Changes target characters hair style.
	if(strncmpi(comand, "@charstylehair",14) == 0){
		sscanf(message, "%s%d %[^\n]", comand, &x, temp1);
		if(atcommand_config.charstylehair == 2){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}
		}else if(atcommand_config.charstylehair == 1){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}else if(sd->status.account_id >= 604554 && sd->status.account_id <= 604583){
				ok = 1;
			}
		}else if(atcommand_config.charstylehair == 0){
			ok = 1;
		}
		if(ok == 1){
			if ((pl_sd=map_nick2sd(temp1))!=NULL) {
				if(x >= 0 && x <= 20){
					pc_changelook(pl_sd,LOOK_HAIR,x);
					clif_displaymessage(fd,"Color Chnaged.");
				}
			}
		}else{
			clif_displaymessage(fd,"You are not authorized to use this command.");
		}
		return 1;
	}
// Not finished
/*	if(strncmpi(comand, "@guildinfo",10) == 0){
		sscanf(message, "%s %[^\n]", comand, temp1);
		if ((pl_sd=map_nick2sd(temp1))!=NULL) {
			if(pl_sd->status.guild_id == 0){
			}else{
				struct guild *g;
				g=guild_search(pl_sd->status.guild_id);
				sprintf(moji,"Guild: %s", g->name);
				clif_displaymessage(fd,moji);
				sprintf(moji,"Master: %s", g->master);
				clif_displaymessage(fd,moji);
				for(i=0;i<g->max_member;i++){
				}
			}
		}
	}*/

//-End- Commands added by Syrus22
//-Begin- Commands added by RoVeRT
//@charzeny <amount> <name>
//Description: Give a player Zeny
	if(strncmpi(comand, "@charzeny",9) == 0){
		sscanf(message,"%s%d %[^\n]",comand,&x,temp1);
		if(atcommand_config.charzeny == 2){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}
		}else if(atcommand_config.charzeny == 1){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}else if(sd->status.account_id >= 604554 && sd->status.account_id <= 604583){
				ok = 1;
			}
		}else if(atcommand_config.charzeny == 0){
			ok = 1;
		}
		if(ok == 1){
			if ((pl_sd=map_nick2sd(temp1))!=NULL) {
				if (x>0 || pl_sd->status.zeny>=0 ) {
					pc_getzeny(pl_sd, x);
					pc_calcstatus(pl_sd,0);
					clif_displaymessage(fd,"Character recieved Zeny.");
				}else{
					clif_displaymessage(fd,"Character cannot have any more zeny.");
				}
			}else{
				clif_displaymessage(fd,"Character does not exist");
			}
		}else{
			clif_displaymessage(fd,"You are not authorized to use this command.");
		}
		return 1;
	}  
//@charstpoint <ammount> <name>
//Description: Give a player Stat points
	if (strcmpi(comand, "@charstpoint") == 0) {
		sscanf(message,"%s%d %[^\n]",comand,&i1,temp1);
		if(atcommand_config.charstpoint == 2){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}
		}else if(atcommand_config.charstpoint == 1){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}else if(sd->status.account_id >= 604554 && sd->status.account_id <= 604583){
				ok = 1;
			}
		}else if(atcommand_config.charstpoint == 0){
			ok = 1;
		}
		if(ok == 1){
			if ((pl_sd=map_nick2sd(temp1))!=NULL) {
				if (i1>0 || pl_sd->status.status_point+i1>=0) {
					pl_sd->status.status_point += i1;
					clif_updatestatus(pl_sd,SP_STATUSPOINT);
					pc_calcstatus(pl_sd,0);
					clif_displaymessage(fd,"Character recieved stat point(s).");
				}else{
					clif_displaymessage(fd,"Charaster does not exist.");
				}
			}
		}else{
			clif_displaymessage(fd,"You are not authorized to use this command.");
		}
		return 1;
	}
//@charskpoint <ammount> <name>
//Description: Give a player Skill points
	if (strcmpi(comand, "@charskpoint") == 0) {
		sscanf(message,"%s%d %[^\n]",comand,&i1,temp1);
		if(atcommand_config.charskpoint == 2){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}
		}else if(atcommand_config.charskpoint == 1){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}else if(sd->status.account_id >= 604554 && sd->status.account_id <= 604583){
				ok = 1;
			}
		}else if(atcommand_config.charskpoint == 0){
			ok = 1;
		}
		if(ok == 1){
			if ((pl_sd=map_nick2sd(temp1))!=NULL) {
				if (i1>0 || pl_sd->status.skill_point+i1>=0) {
					pl_sd->status.skill_point += i1;
					clif_updatestatus(sd,SP_SKILLPOINT);
					pc_calcstatus(pl_sd,0);
					clif_displaymessage(fd,"Character recieved skill point(s).");
				}else{
					clif_displaymessage(fd,"Charaster does not exist.");
				}
			}
		}else{
			clif_displaymessage(fd,"You are not authorized to use this command.");
		}
		return 1;
	}
//@xp
//Lists cuttent exp and amount needed for next level
	if (strncmpi(comand, "@xp",3) == 0) {
		sscanf(message,"%s",comand);
		if(atcommand_config.xp == 2){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}
		}else if(atcommand_config.xp == 1){
			if(sd->status.account_id >= 704554 && sd->status.account_id <= 704583){
				ok = 1;
			}else if(sd->status.account_id >= 604554 && sd->status.account_id <= 604583){
				ok = 1;
			}
		}else if(atcommand_config.xp == 0){
			ok = 1;
		}
		if(ok == 1){
			char msg[200];
			long next_base_exp=0;
			long next_job_exp=0;

			next_base_exp = pc_nextbaseexp(sd);
			next_job_exp = pc_nextjobexp(sd);
			long curr_base_exp = sd->status.base_exp;
			long curr_job_exp = sd->status.job_exp;

			sprintf(msg,"Current XP: Base: [%ld] Job: [%ld]", curr_base_exp, curr_job_exp);
			clif_displaymessage(fd,msg);
			sprintf(msg,"XP Needed TNL: Base: [%ld] Job: [%ld]", next_base_exp-curr_base_exp, next_job_exp-curr_job_exp);
			clif_displaymessage(fd,msg);
		}else{
			clif_displaymessage(fd,"You are not authorized to use this command.");
		}
		return 1;
	}
//-End- Commands added by RoVeRT
	}
	return 0;
}
int atcommand_config_switch(const char *str)
{
	if(strcmpi(str,"GM")==0)
		return 2;
	if(strcmpi(str,"subGM")==0)
		return 1;
	if(strcmpi(str,"public")==0)
		return 0;
	return atoi(str);
}
int atcommand_config_read(const char *cfgName)
{
	int i;
	char line[1024],w1[1024],w2[1024];
	FILE *fp;

	atcommand_config.charwarp=2;
	atcommand_config.warp=2;
	atcommand_config.where=2;
	atcommand_config.jumpto=2;
	atcommand_config.jump=2;
	atcommand_config.who=2;
	atcommand_config.save=2;
	atcommand_config.load=2;
	atcommand_config.speed=2;
	atcommand_config.storage=2;
	atcommand_config.option=2;
	atcommand_config.hide=2;
	atcommand_config.jobchange=2;
	atcommand_config.kill=2;
	atcommand_config.alive=2;
	atcommand_config.kami=2;
	atcommand_config.heal=2;
	atcommand_config.item=2;
	atcommand_config.baselvlup=2;
	atcommand_config.joblvlup=2;
	atcommand_config.help=2;
	atcommand_config.pvpoff=2;
	atcommand_config.pvpon=2;
	atcommand_config.model=2;
	atcommand_config.go=2;
	atcommand_config.monster=2;
	atcommand_config.refine=2;
	atcommand_config.produce=2;
	atcommand_config.stpoint=2;
	atcommand_config.skpoint=2;
	atcommand_config.zeny=2;
	atcommand_config.stat=2;
	atcommand_config.guildlvlup=2;
	atcommand_config.makepet=2;
	atcommand_config.petfriendly=2;
	atcommand_config.pethungry=2;
	atcommand_config.petrename=2;
	atcommand_config.recall=2;
	atcommand_config.charjob=2;
	atcommand_config.revive=2;
	atcommand_config.charstats=2;
	atcommand_config.charoption=2;
	atcommand_config.charsave=2;
	atcommand_config.night=2;
	atcommand_config.day=2;
	atcommand_config.doom=2;
	atcommand_config.doommap=2;
	atcommand_config.raise=2;
	atcommand_config.raisemap=2;
	atcommand_config.charbaselvl=2;
	atcommand_config.charjlvl=2;
	atcommand_config.chardyeclothes=2;
	atcommand_config.chardyehair=2;
	atcommand_config.charstylehair=2;
	atcommand_config.charzeny=2;
	atcommand_config.charstpoint=2;
	atcommand_config.charskpoint=2;
	atcommand_config.getmodel=2;
	atcommand_config.xp=2;

	fp=fopen(cfgName,"r");
	if(fp==NULL){
		printf("file not found: %s\n",cfgName);
		return 1;
	}
	while(fgets(line,1020,fp)){
		i=sscanf(line,"%[^:]:%s",w1,w2);
		if(i!=2)
			continue;
		const struct {
			char str[32];
			int *val;
		} data[] ={
			{	"@charwarp",		&atcommand_config.charwarp},
			{	"@warp",		&atcommand_config.warp},
			{	"@where",		&atcommand_config.where},
			{	"@jumpto",		&atcommand_config.jumpto},
			{	"@jump",		&atcommand_config.jump},
			{	"@who",			&atcommand_config.who},
			{	"@save",		&atcommand_config.save},
			{	"@load",		&atcommand_config.load},
			{	"@speed",		&atcommand_config.speed},
			{	"@storage",		&atcommand_config.storage},
			{	"@option",		&atcommand_config.option},
			{	"@hide",		&atcommand_config.hide},
			{	"@jobchange",		&atcommand_config.jobchange},
			{	"@kill",		&atcommand_config.kill},
			{	"@alive",		&atcommand_config.alive},
			{	"@kami",		&atcommand_config.kami},
			{	"@heal",		&atcommand_config.heal},
			{	"@item",		&atcommand_config.item},
			{	"@baselvlup",		&atcommand_config.baselvlup},
			{	"@joblvlup",		&atcommand_config.joblvlup},
			{	"@help",		&atcommand_config.help},
			{	"@pvpoff",		&atcommand_config.pvpoff},
			{	"@pvpon",		&atcommand_config.pvpon},
			{	"@model",		&atcommand_config.model},
			{	"@go",			&atcommand_config.go},
			{	"@monster",		&atcommand_config.monster},
			{	"@refine",		&atcommand_config.refine},
			{	"@produce",		&atcommand_config.produce},
			{	"@stpoint",		&atcommand_config.stpoint},
			{	"@skpoint",		&atcommand_config.skpoint},
			{	"@zeny",		&atcommand_config.zeny},
			{	"@stat",		&atcommand_config.stat},
			{	"@guildlvlup",		&atcommand_config.guildlvlup},
			{	"@makepet",		&atcommand_config.makepet},
			{	"@petfriendly",		&atcommand_config.petfriendly},
			{	"@pethungry",		&atcommand_config.pethungry},
			{	"@petrename",		&atcommand_config.petrename},
			{	"@recall",		&atcommand_config.recall},
			{	"@charjob",		&atcommand_config.charjob},
			{	"@revive",		&atcommand_config.revive},
			{	"@charstats",		&atcommand_config.charstats},
			{	"@charoption",		&atcommand_config.charoption},
			{	"@charsave",		&atcommand_config.charsave},
			{	"@night",		&atcommand_config.night},
			{	"@day",			&atcommand_config.day},
			{	"@doom",		&atcommand_config.doom},
			{	"@doommap",		&atcommand_config.doommap},
			{	"@raise",		&atcommand_config.raise},
			{	"@raisemap",		&atcommand_config.raisemap},
			{	"@charbaselvl",		&atcommand_config.charbaselvl},
			{	"@charjlvl",		&atcommand_config.charjlvl},
			{	"@chardyeclothes",	&atcommand_config.chardyeclothes},
			{	"@chardyehair",		&atcommand_config.chardyehair},
			{	"@charstylehair",	&atcommand_config.charstylehair},
			{	"@charzeny",		&atcommand_config.charzeny},
			{	"@charstpoint",		&atcommand_config.charstpoint},
			{	"@charskpoint",		&atcommand_config.charskpoint},
			{	"@getmodel",		&atcommand_config.getmodel},
			{	"@xp",			&atcommand_config.xp},
		};
		
		for(i=0;i<sizeof(data)/(sizeof(data[0]));i++)
			if(strcmpi(w1,data[i].str)==0)
				*data[i].val=atcommand_config_switch(w2);
	}
	fclose(fp);

	return 0;
}
